{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}


module Curry_SetRBT (C_SetRBT, d_C_emptySetRBT, nd_C_emptySetRBT, d_C_isEmptySetRBT, nd_C_isEmptySetRBT, d_C_elemRBT, nd_C_elemRBT, d_C_insertRBT, nd_C_insertRBT, d_C_insertMultiRBT, nd_C_insertMultiRBT, d_C_deleteRBT, nd_C_deleteRBT, d_C_setRBT2list, nd_C_setRBT2list, d_C_unionRBT, nd_C_unionRBT, d_C_intersectRBT, nd_C_intersectRBT, d_C_sortRBT, nd_C_sortRBT) where

import Basics
import qualified Curry_Maybe
import qualified Curry_Prelude
import qualified Curry_RedBlackTree

type C_SetRBT t0 = Curry_RedBlackTree.C_RedBlackTree t0

d_C_emptySetRBT :: Curry_Prelude.Curry t0 => Cover -> ConstStore -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
d_C_emptySetRBT cd cs = Curry_RedBlackTree.d_C_empty (acceptCs id Curry_Prelude.d_OP_eq_eq) (acceptCs id Curry_Prelude.d_OP_eq_eq)

nd_C_emptySetRBT :: Curry_Prelude.Curry t0 => IDSupply -> Cover -> ConstStore -> Func (Func t0 (Func t0 Curry_Prelude.C_Bool)) (Curry_RedBlackTree.C_RedBlackTree t0)
nd_C_emptySetRBT s cd cs = wrapNX id (Curry_RedBlackTree.nd_C_empty (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_eq_eq)) (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_eq_eq)))

d_C_isEmptySetRBT :: Curry_Prelude.Curry t0 => Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isEmptySetRBT cd cs = Curry_RedBlackTree.d_C_isEmpty

nd_C_isEmptySetRBT :: Curry_Prelude.Curry t0 => IDSupply -> Cover -> ConstStore -> Func (Curry_RedBlackTree.C_RedBlackTree t0) Curry_Prelude.C_Bool
nd_C_isEmptySetRBT s cd cs = wrapNX id Curry_RedBlackTree.nd_C_isEmpty

d_C_elemRBT :: Curry_Prelude.Curry t0 => t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_elemRBT x1 cd cs = Curry_Prelude.d_OP_dot Curry_Maybe.d_C_isJust (Curry_RedBlackTree.d_C_lookup x1) cd cs

nd_C_elemRBT :: Curry_Prelude.Curry t0 => t0 -> IDSupply -> Cover -> ConstStore -> Func (Curry_RedBlackTree.C_RedBlackTree t0) Curry_Prelude.C_Bool
nd_C_elemRBT x1 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.nd_OP_dot (wrapDX id Curry_Maybe.d_C_isJust) (wrapNX id (Curry_RedBlackTree.nd_C_lookup x1)) s0 cd cs)))

d_C_insertRBT :: Curry_Prelude.Curry t0 => Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
d_C_insertRBT cd cs = acceptCs id Curry_RedBlackTree.d_C_update

nd_C_insertRBT :: Curry_Prelude.Curry t0 => IDSupply -> Cover -> ConstStore -> Func t0 (Func (Curry_RedBlackTree.C_RedBlackTree t0) (Curry_RedBlackTree.C_RedBlackTree t0))
nd_C_insertRBT s cd cs = wrapDX (wrapNX id) (acceptCs id Curry_RedBlackTree.nd_C_update)

d_C_insertMultiRBT :: Curry_Prelude.Curry t0 => t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
d_C_insertMultiRBT x1 cd cs = Curry_Prelude.d_OP_dot (Curry_RedBlackTree.d_C_setInsertEquivalence (acceptCs id Curry_Prelude.d_OP_eq_eq)) (Curry_Prelude.d_OP_dot (Curry_RedBlackTree.d_C_update x1) (Curry_RedBlackTree.d_C_setInsertEquivalence (acceptCs id d_OP_insertMultiRBT_dot_uscore_hash_lambda1)) cd cs) cd cs

nd_C_insertMultiRBT :: Curry_Prelude.Curry t0 => t0 -> IDSupply -> Cover -> ConstStore -> Func (Curry_RedBlackTree.C_RedBlackTree t0) (Curry_RedBlackTree.C_RedBlackTree t0)
nd_C_insertMultiRBT x1 s cd cs = let
     s2 = s
      in (seq s2 (let
          s1 = leftSupply s2
          s0 = rightSupply s2
           in (seq s1 (seq s0 (Curry_Prelude.nd_OP_dot (wrapNX id (Curry_RedBlackTree.nd_C_setInsertEquivalence (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_eq_eq)))) (let
                in (Curry_Prelude.nd_OP_dot (wrapNX id (Curry_RedBlackTree.nd_C_update x1)) (wrapNX id (Curry_RedBlackTree.nd_C_setInsertEquivalence (wrapDX (wrapDX id) (acceptCs id d_OP_insertMultiRBT_dot_uscore_hash_lambda1)))) s0 cd cs)) s1 cd cs)))))

d_OP_insertMultiRBT_dot_uscore_hash_lambda1 :: Curry_Prelude.Curry t0 => t0 -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_insertMultiRBT_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.C_False

d_C_deleteRBT :: Curry_Prelude.Curry t0 => Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
d_C_deleteRBT cd cs = acceptCs id Curry_RedBlackTree.d_C_delete

nd_C_deleteRBT :: Curry_Prelude.Curry t0 => IDSupply -> Cover -> ConstStore -> Func t0 (Func (Curry_RedBlackTree.C_RedBlackTree t0) (Curry_RedBlackTree.C_RedBlackTree t0))
nd_C_deleteRBT s cd cs = wrapDX (wrapNX id) (acceptCs id Curry_RedBlackTree.nd_C_delete)

d_C_setRBT2list :: Curry_Prelude.Curry t0 => Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_setRBT2list cd cs = Curry_RedBlackTree.d_C_tree2list

nd_C_setRBT2list :: Curry_Prelude.Curry t0 => IDSupply -> Cover -> ConstStore -> Func (Curry_RedBlackTree.C_RedBlackTree t0) (Curry_Prelude.OP_List t0)
nd_C_setRBT2list s cd cs = wrapNX id Curry_RedBlackTree.nd_C_tree2list

d_C_unionRBT :: Curry_Prelude.Curry t0 => Curry_RedBlackTree.C_RedBlackTree t0 -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
d_C_unionRBT x1 x2 cd cs = Curry_Prelude.d_C_foldr (d_C_insertRBT cd cs) x2 (Curry_Prelude.d_C_apply (d_C_setRBT2list cd cs) x1 cd cs) cd cs

nd_C_unionRBT :: Curry_Prelude.Curry t0 => Curry_RedBlackTree.C_RedBlackTree t0 -> Curry_RedBlackTree.C_RedBlackTree t0 -> IDSupply -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
nd_C_unionRBT x1 x2 s cd cs = let
     s5 = s
      in (seq s5 (let
          s4 = leftSupply s5
          s6 = rightSupply s5
          s0 = leftSupply s6
          s3 = rightSupply s6
           in (seq s4 (seq s6 (seq s0 (seq s3 (Curry_Prelude.nd_C_foldr (let
                in (nd_C_insertRBT s0 cd cs)) x2 (let
               s2 = leftSupply s3
               s1 = rightSupply s3
                in (seq s2 (seq s1 (Curry_Prelude.nd_C_apply (let
                     in (nd_C_setRBT2list s1 cd cs)) x1 s2 cd cs)))) s4 cd cs)))))))

d_C_intersectRBT :: Curry_Prelude.Curry t0 => Curry_RedBlackTree.C_RedBlackTree t0 -> Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
d_C_intersectRBT x1 x2 cd cs = Curry_Prelude.d_C_foldr (d_C_insertRBT cd cs) (Curry_RedBlackTree.d_C_newTreeLike x1 cd cs) (Curry_Prelude.d_C_filter (d_OP_intersectRBT_dot_uscore_hash_lambda2 x2) (Curry_Prelude.d_C_apply (d_C_setRBT2list cd cs) x1 cd cs) cd cs) cd cs

nd_C_intersectRBT :: Curry_Prelude.Curry t0 => Curry_RedBlackTree.C_RedBlackTree t0 -> Curry_RedBlackTree.C_RedBlackTree t0 -> IDSupply -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree t0
nd_C_intersectRBT x1 x2 s cd cs = let
     s8 = s
      in (seq s8 (let
          s9 = leftSupply s8
          s10 = rightSupply s8
          s7 = leftSupply s9
          s0 = rightSupply s9
          s1 = leftSupply s10
          s6 = rightSupply s10
           in (seq s9 (seq s10 (seq s7 (seq s0 (seq s1 (seq s6 (Curry_Prelude.nd_C_foldr (let
                in (nd_C_insertRBT s0 cd cs)) (let
                in (Curry_RedBlackTree.nd_C_newTreeLike x1 s1 cd cs)) (let
               s5 = leftSupply s6
               s4 = rightSupply s6
                in (seq s5 (seq s4 (Curry_Prelude.nd_C_filter (wrapNX id (nd_OP_intersectRBT_dot_uscore_hash_lambda2 x2)) (let
                    s3 = leftSupply s4
                    s2 = rightSupply s4
                     in (seq s3 (seq s2 (Curry_Prelude.nd_C_apply (let
                          in (nd_C_setRBT2list s2 cd cs)) x1 s3 cd cs)))) s5 cd cs)))) s7 cd cs)))))))))

d_OP_intersectRBT_dot_uscore_hash_lambda2 :: Curry_Prelude.Curry t0 => Curry_RedBlackTree.C_RedBlackTree t0 -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_intersectRBT_dot_uscore_hash_lambda2 x1 x2 cd cs = Curry_Prelude.d_C_apply (d_C_elemRBT x2 cd cs) x1 cd cs

nd_OP_intersectRBT_dot_uscore_hash_lambda2 :: Curry_Prelude.Curry t0 => Curry_RedBlackTree.C_RedBlackTree t0 -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_intersectRBT_dot_uscore_hash_lambda2 x1 x2 s cd cs = let
     s2 = s
      in (seq s2 (let
          s1 = leftSupply s2
          s0 = rightSupply s2
           in (seq s1 (seq s0 (Curry_Prelude.nd_C_apply (let
                in (nd_C_elemRBT x2 s0 cd cs)) x1 s1 cd cs)))))

d_C_sortRBT :: Curry_Prelude.Curry t0 => Cover -> ConstStore -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_sortRBT cd cs = acceptCs id Curry_RedBlackTree.d_C_sort

nd_C_sortRBT :: Curry_Prelude.Curry t0 => IDSupply -> Cover -> ConstStore -> Func (Func t0 (Func t0 Curry_Prelude.C_Bool)) (Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0))
nd_C_sortRBT s cd cs = wrapDX (wrapNX id) (acceptCs id Curry_RedBlackTree.nd_C_sort)