{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}


module Curry_AbstractCurryGoodies (d_C_isPolyType, d_C_isFunctionalType, d_C_isIOType, d_C_isIOReturnType, d_C_modsOfType, d_C_showMonoTypeExpr) where

import Basics
import qualified Curry_AbstractCurry
import qualified Curry_List
import qualified Curry_Prelude
import qualified Curry_Utils

d_C_isPolyType :: Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isPolyType x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CTVar x2) -> Curry_Prelude.C_True
     (Curry_AbstractCurry.C_CFuncType x3 x4) -> Curry_Prelude.d_OP_bar_bar (d_C_isPolyType x3 cd cs) (d_C_isPolyType x4 cd cs) cd cs
     (Curry_AbstractCurry.C_CTCons x5 x6) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_isPolyType cd cs) x6 cd cs
     (Curry_AbstractCurry.C_CRecordType x7 x8) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_any d_C_isPolyType cd cs) (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x7 cd cs) cd cs
     (Curry_AbstractCurry.Choice_C_CTypeExpr d i l r) -> narrow d i (d_C_isPolyType l cd cs) (d_C_isPolyType r cd cs)
     (Curry_AbstractCurry.Choices_C_CTypeExpr d i xs) -> narrows cs d i (\z -> d_C_isPolyType z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CTypeExpr d c e) -> guardCons d c ((d_C_isPolyType e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CTypeExpr d info) -> failCons d (traceFail "AbstractCurryGoodies.isPolyType" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.isPolyType" (showCons x1))

d_C_isFunctionalType :: Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isFunctionalType x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CFuncType x2 x3) -> Curry_Prelude.C_True
     (Curry_AbstractCurry.C_CTVar x4) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.C_CTCons x5 x6) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.C_CRecordType x7 x8) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.Choice_C_CTypeExpr d i l r) -> narrow d i (d_C_isFunctionalType l cd cs) (d_C_isFunctionalType r cd cs)
     (Curry_AbstractCurry.Choices_C_CTypeExpr d i xs) -> narrows cs d i (\z -> d_C_isFunctionalType z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CTypeExpr d c e) -> guardCons d c ((d_C_isFunctionalType e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CTypeExpr d info) -> failCons d (traceFail "AbstractCurryGoodies.isFunctionalType" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.isFunctionalType" (showCons x1))

d_C_isIOType :: Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isIOType x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CTCons x2 x3) -> Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.OP_Tuple2 (d_C_prelude cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) Curry_Prelude.OP_List))) cd cs
     (Curry_AbstractCurry.C_CTVar x4) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.C_CFuncType x5 x6) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.C_CRecordType x7 x8) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.Choice_C_CTypeExpr d i l r) -> narrow d i (d_C_isIOType l cd cs) (d_C_isIOType r cd cs)
     (Curry_AbstractCurry.Choices_C_CTypeExpr d i xs) -> narrows cs d i (\z -> d_C_isIOType z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CTypeExpr d c e) -> guardCons d c ((d_C_isIOType e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CTypeExpr d info) -> failCons d (traceFail "AbstractCurryGoodies.isIOType" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.isIOType" (showCons x1))

d_C_isIOReturnType :: Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isIOReturnType x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CTVar x2) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.C_CFuncType x3 x4) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.C_CTCons x5 x6) -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_eq x5 (Curry_Prelude.OP_Tuple2 (d_C_prelude cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) Curry_Prelude.OP_List))) cd cs) (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_slash_eq (Curry_Prelude.d_C_head x6 cd cs) (Curry_AbstractCurry.C_CTCons (Curry_Prelude.OP_Tuple2 (d_C_prelude cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List))) Curry_Prelude.OP_List) cd cs) (Curry_Prelude.d_C_not (d_C_isFunctionalType (Curry_Prelude.d_C_head x6 cd cs) cd cs) cd cs) cd cs) cd cs
     (Curry_AbstractCurry.C_CRecordType x7 x8) -> Curry_Prelude.C_False
     (Curry_AbstractCurry.Choice_C_CTypeExpr d i l r) -> narrow d i (d_C_isIOReturnType l cd cs) (d_C_isIOReturnType r cd cs)
     (Curry_AbstractCurry.Choices_C_CTypeExpr d i xs) -> narrows cs d i (\z -> d_C_isIOReturnType z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CTypeExpr d c e) -> guardCons d c ((d_C_isIOReturnType e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CTypeExpr d info) -> failCons d (traceFail "AbstractCurryGoodies.isIOReturnType" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.isIOReturnType" (showCons x1))

d_C_modsOfType :: Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_modsOfType x1 cd cs = case x1 of
     (Curry_AbstractCurry.C_CTVar x2) -> Curry_Prelude.OP_List
     (Curry_AbstractCurry.C_CFuncType x3 x4) -> Curry_List.d_C_union (d_C_modsOfType x3 cd cs) (d_C_modsOfType x4 cd cs) cd cs
     (Curry_AbstractCurry.C_CTCons x5 x6) -> d_C__case_12 x6 x5 cd cs
     (Curry_AbstractCurry.C_CRecordType x9 x10) -> Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_foldr (acceptCs id Curry_List.d_C_union) Curry_Prelude.OP_List) (Curry_Prelude.d_C_map (Curry_Prelude.d_OP_dot d_C_modsOfType Curry_Prelude.d_C_snd cd cs) x9 cd cs) cd cs
     (Curry_AbstractCurry.Choice_C_CTypeExpr d i l r) -> narrow d i (d_C_modsOfType l cd cs) (d_C_modsOfType r cd cs)
     (Curry_AbstractCurry.Choices_C_CTypeExpr d i xs) -> narrows cs d i (\z -> d_C_modsOfType z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CTypeExpr d c e) -> guardCons d c ((d_C_modsOfType e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CTypeExpr d info) -> failCons d (traceFail "AbstractCurryGoodies.modsOfType" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.modsOfType" (showCons x1))

d_C_showMonoTypeExpr :: Curry_Prelude.C_Bool -> Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showMonoTypeExpr x1 x2 cd cs = d_C_showMonoTypeExpr' x1 Curry_Prelude.C_False x2 cd cs

d_C_showMonoTypeExpr' :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showMonoTypeExpr' x1 x2 x3 cd cs = case x3 of
     (Curry_AbstractCurry.C_CTVar x4) -> d_C__case_11 x1 x4 cd cs
     (Curry_AbstractCurry.C_CFuncType x7 x8) -> Curry_Prelude.d_OP_dollar (d_C_parens x2) (Curry_Prelude.d_OP_plus_plus (d_C_showMonoTypeExpr' x1 (d_C_isFunctionalType x7 cd cs) x7 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '>'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))) (d_C_showMonoTypeExpr' x1 Curry_Prelude.C_False x8 cd cs) cd cs) cd cs) cd cs
     (Curry_AbstractCurry.C_CTCons x9 x10) -> d_C__case_9 x10 x1 x2 x9 cd cs
     (Curry_AbstractCurry.C_CRecordType x13 x14) -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '{'#) (Curry_Prelude.d_OP_plus_plus (Curry_List.d_C_intercalate (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ','#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)) (Curry_Prelude.d_C_map (d_C_showField x1 x2) x13 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '}'#) Curry_Prelude.OP_List) cd cs)
     (Curry_AbstractCurry.Choice_C_CTypeExpr d i l r) -> narrow d i (d_C_showMonoTypeExpr' x1 x2 l cd cs) (d_C_showMonoTypeExpr' x1 x2 r cd cs)
     (Curry_AbstractCurry.Choices_C_CTypeExpr d i xs) -> narrows cs d i (\z -> d_C_showMonoTypeExpr' x1 x2 z cd cs) xs
     (Curry_AbstractCurry.Guard_C_CTypeExpr d c e) -> guardCons d c ((d_C_showMonoTypeExpr' x1 x2 e cd) $! (addCs c cs))
     (Curry_AbstractCurry.Fail_C_CTypeExpr d info) -> failCons d (traceFail "AbstractCurryGoodies.showMonoTypeExpr'" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.showMonoTypeExpr'" (showCons x3))

d_C_showTypeCons :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTypeCons x1 x2 x3 x4 cd cs = case x4 of
     Curry_Prelude.OP_List -> x3
     (Curry_Prelude.OP_Cons x5 x6) -> d_C__case_6 x2 x4 x1 x3 (Curry_Prelude.d_OP_eq_eq x2 (d_C_prelude cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_showTypeCons x1 x2 x3 l cd cs) (d_C_showTypeCons x1 x2 x3 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_showTypeCons x1 x2 x3 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_showTypeCons x1 x2 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractCurryGoodies.showTypeCons" [(show x1),(show x2),(show x3),(show x4)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.showTypeCons" (showCons x4))

d_C_showPreludeTypeCons :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showPreludeTypeCons x1 x2 x3 cd cs = d_C__case_4 x3 x2 x1 (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ']'#) Curry_Prelude.OP_List)) cd cs) (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_head x3 cd cs) (Curry_AbstractCurry.C_CTCons (Curry_Prelude.OP_Tuple2 (d_C_prelude cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) Curry_Prelude.OP_List))))) Curry_Prelude.OP_List) cd cs) cd cs) cd cs

d_C_showField :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_AbstractCurry.C_CTypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showField x1 x2 x3 cd cs = case x3 of
     (Curry_Prelude.OP_Tuple2 x4 x5) -> Curry_Prelude.d_OP_plus_plus x4 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))) (d_C_showMonoTypeExpr' x1 x2 x5 cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C_showField x1 x2 l cd cs) (d_C_showField x1 x2 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C_showField x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C_showField x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractCurryGoodies.showField" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.showField" (showCons x3))

d_C_showIdentifier :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showIdentifier cd cs = Curry_Prelude.d_C_filter (Curry_Prelude.d_C_flip Curry_Prelude.d_C_notElem (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '<'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '>'#) Curry_Prelude.OP_List)))

d_C_prelude :: Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_prelude cd cs = Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))

d_C_parens :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_parens x1 x2 cd cs = case x1 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs)
     Curry_Prelude.C_False -> x2
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C_parens l x2 cd cs) (d_C_parens r x2 cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C_parens z x2 cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C_parens e x2 cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies.parens" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.parens" (showCons x1))

d_C_prefixMap :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_C_prefixMap x1 x2 x3 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap (Curry_Prelude.d_OP_plus_plus x3) cd cs) (Curry_Prelude.d_C_map x1 x2 cd cs) cd cs

nd_C_prefixMap :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Func t0 (Curry_Prelude.OP_List t1) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
nd_C_prefixMap x1 x2 x3 s cd cs = let
     s3 = s
      in (seq s3 (let
          s2 = leftSupply s3
          s4 = rightSupply s3
          s0 = leftSupply s4
          s1 = rightSupply s4
           in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (let
                in (Curry_Prelude.nd_C_concatMap (wrapDX id (Curry_Prelude.d_OP_plus_plus x3)) s0 cd cs)) (let
                in (Curry_Prelude.nd_C_map x1 x2 s1 cd cs)) s2 cd cs)))))))

d_C_combineMap :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_C_combineMap x1 x2 x3 cd cs = case x2 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x4 x5) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply x1 x4 cd cs) (d_C_prefixMap x1 x5 x3 cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_combineMap x1 l x3 cd cs) (d_C_combineMap x1 r x3 cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_combineMap x1 z x3 cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_combineMap x1 e x3 cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractCurryGoodies.combineMap" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.combineMap" (showCons x2))

nd_C_combineMap :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Func t0 (Curry_Prelude.OP_List t1) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List t1 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
nd_C_combineMap x1 x2 x3 s cd cs = case x2 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x4 x5) -> let
          s2 = s
           in (seq s2 (let
               s0 = leftSupply s2
               s1 = rightSupply s2
                in (seq s0 (seq s1 (Curry_Prelude.d_OP_plus_plus (let
                     in (Curry_Prelude.nd_C_apply x1 x4 s0 cd cs)) (let
                     in (nd_C_prefixMap x1 x5 x3 s1 cd cs)) cd cs)))))
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (nd_C_combineMap x1 l x3 s cd cs) (nd_C_combineMap x1 r x3 s cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> nd_C_combineMap x1 z x3 s cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((nd_C_combineMap x1 e x3 s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractCurryGoodies.combineMap" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.combineMap" (showCons x2))

d_C_isTuple :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isTuple x1 cd cs = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.C_False
     (Curry_Prelude.OP_Cons x2 x3) -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Char '('#) cd cs) (d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 x3 cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_isTuple l cd cs) (d_C_isTuple r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_isTuple z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_isTuple e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractCurryGoodies.isTuple" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.isTuple" (showCons x1))

d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 x1 cd cs = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.C_False
     (Curry_Prelude.OP_Cons x2 x3) -> d_C__case_0 x2 x3 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 l cd cs) (d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractCurryGoodies.isTuple.p1_isTuple.97" [(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies.isTuple.p1_isTuple.97" (showCons x1))

d_C__case_0 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x2 x3 cd cs = case x3 of
     Curry_Prelude.OP_List -> Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Char ')'#) cd cs
     (Curry_Prelude.OP_Cons x4 x5) -> Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.C_Char ','#) cd cs) (d_OP_isTuple_dot_p1_uscore_isTuple_dot_97 (Curry_Prelude.OP_Cons x4 x5) cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C__case_0 x2 l cd cs) (d_C__case_0 x2 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C__case_0 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C__case_0 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "AbstractCurryGoodies._case_0" [(show x2),(show x3)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_0" (showCons x3))

d_C__case_4 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_4 x3 x2 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'S'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) Curry_Prelude.OP_List)))))
     Curry_Prelude.C_False -> d_C__case_3 x2 x3 x1 (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ']'#) Curry_Prelude.OP_List)) cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_4 x3 x2 x1 l cd cs) (d_C__case_4 x3 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_4 x3 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_4 x3 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_4" [(show x3),(show x2),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_4" (showCons x4))

d_C__case_3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_3 x2 x3 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) Curry_Prelude.OP_List) (Curry_Prelude.d_OP_plus_plus (d_C_showMonoTypeExpr' x1 Curry_Prelude.C_False (Curry_Prelude.d_C_head x3 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ']'#) Curry_Prelude.OP_List) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_2 x2 x3 x1 (d_C_isTuple x2 cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_3 x2 x3 x1 l cd cs) (d_C__case_3 x2 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_3 x2 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_3 x2 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_3" [(show x2),(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_3" (showCons x4))

d_C__case_2 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x2 x3 x1 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) Curry_Prelude.OP_List) (Curry_Prelude.d_OP_plus_plus (d_C_combineMap (d_C_showMonoTypeExpr' x1 Curry_Prelude.C_False) x3 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ','#) Curry_Prelude.OP_List) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs) cd cs
     Curry_Prelude.C_False -> d_C__case_1 x3 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_2 x2 x3 x1 l cd cs) (d_C__case_2 x2 x3 x1 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_2 x2 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_2 x2 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_2" [(show x2),(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_2" (showCons x4))

d_C__case_1 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x3 x1 x2 x4 cd cs = case x4 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x2 (d_C_prefixMap (d_C_showMonoTypeExpr' x1 Curry_Prelude.C_True) x3 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List) cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_1 x3 x1 x2 l cd cs) (d_C__case_1 x3 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_1 x3 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_1 x3 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_1" [(show x3),(show x1),(show x2),(show x4)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_1" (showCons x4))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_6 x2 x4 x1 x3 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> d_C_showPreludeTypeCons x1 x3 x4 cd cs
     Curry_Prelude.C_False -> d_C__case_5 x4 x1 x3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_6 x2 x4 x1 x3 l cd cs) (d_C__case_6 x2 x4 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_6 x2 x4 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_6 x2 x4 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_6" [(show x2),(show x4),(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_6" (showCons x5))

d_C__case_5 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_5 x4 x1 x3 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x3 (d_C_prefixMap (d_C_showMonoTypeExpr' x1 Curry_Prelude.C_True) x4 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List) cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_5 x4 x1 x3 l cd cs) (d_C__case_5 x4 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_5 x4 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_5 x4 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_5" [(show x4),(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_5" (showCons x5))

d_C__case_9 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_9 x10 x1 x2 x9 cd cs = case x9 of
     (Curry_Prelude.OP_Tuple2 x11 x12) -> d_C__case_8 x12 x11 x10 x1 x2 (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_eq_eq x11 (d_C_prelude cd cs) cd cs) (Curry_Prelude.d_OP_eq_eq x12 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) Curry_Prelude.OP_List))))))) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_9 x10 x1 x2 l cd cs) (d_C__case_9 x10 x1 x2 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_9 x10 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_9 x10 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractCurryGoodies._case_9" [(show x10),(show x1),(show x2),(show x9)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_9" (showCons x9))

d_C__case_8 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_8 x12 x11 x10 x1 x2 x13 cd cs = case x13 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) Curry_Prelude.OP_List
     Curry_Prelude.C_False -> d_C__case_7 x10 x12 x11 x1 x2 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_8 x12 x11 x10 x1 x2 l cd cs) (d_C__case_8 x12 x11 x10 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_8 x12 x11 x10 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_8 x12 x11 x10 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_8" [(show x12),(show x11),(show x10),(show x1),(show x2),(show x13)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_8" (showCons x13))

d_C__case_7 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_7 x10 x12 x11 x1 x2 x13 cd cs = case x13 of
     Curry_Prelude.C_True -> d_C_parens (Curry_Prelude.d_OP_amp_amp x2 (Curry_Prelude.d_C_apply (Curry_Utils.d_C_notNull cd cs) x10 cd cs) cd cs) (d_C_showTypeCons x1 x11 x12 x10 cd cs) cd cs
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_7 x10 x12 x11 x1 x2 l cd cs) (d_C__case_7 x10 x12 x11 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_7 x10 x12 x11 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_7 x10 x12 x11 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_7" [(show x10),(show x12),(show x11),(show x1),(show x2),(show x13)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_7" (showCons x13))

d_C__case_11 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_11 x1 x4 cd cs = case x4 of
     (Curry_Prelude.OP_Tuple2 x5 x6) -> d_C__case_10 x6 x1 cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_11 x1 l cd cs) (d_C__case_11 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_11 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_11 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractCurryGoodies._case_11" [(show x1),(show x4)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_11" (showCons x4))

d_C__case_10 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_10 x6 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (d_C_showIdentifier cd cs) x6 cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_10 x6 l cd cs) (d_C__case_10 x6 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_10 x6 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_10 x6 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "AbstractCurryGoodies._case_10" [(show x6),(show x1)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_10" (showCons x1))

d_C__case_12 :: Curry_Prelude.OP_List Curry_AbstractCurry.C_CTypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_12 x6 x5 cd cs = case x5 of
     (Curry_Prelude.OP_Tuple2 x7 x8) -> Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_foldr (acceptCs id Curry_List.d_C_union) (Curry_Prelude.OP_Cons x7 Curry_Prelude.OP_List)) (Curry_Prelude.d_C_map d_C_modsOfType x6 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_12 x6 l cd cs) (d_C__case_12 x6 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_12 x6 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_12 x6 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "AbstractCurryGoodies._case_12" [(show x6),(show x5)] info)
     _ -> failCons cd (consFail "AbstractCurryGoodies._case_12" (showCons x5))